<template>
  <div class="restaurant-item">
    <div class="restaurant-item-inner-wrapper" :class="themeClasses">
      <template v-if="restaurant">
        <component
          :is="tag"
          class="restaurant"
          :to="link()"
          :class="{ 'restaurant-item--close': close }"
        >
          <div class="restaurant-block">
            <component
              :is="tagForLogo"
              class="flex d-md-block restaurant-block-top"
              :class="isRecommendation ? 'mb-0' : ''"
              :to="link()"
            >
              <div>
                <div
                  :style="{ 'background-image': `url('${thumbnail}')` }"
                  class="restaurant-logo"
                ></div>
              </div>
              <div class="restaurant-content flex-1 flex flex-column">
                <template v-if="isWaitingStrategy && !restaurant.closed">
                  <div
                    class="waiting-minutes-badge"
                    v-if="
                      !isVipMember &&
                        !restaurant.longWaiting &&
                        restaurant.estimatedWaitingMinutes
                    "
                  >
                    {{
                      $t("restaurant.waitingTime2", {
                        minutes: restaurant.estimatedWaitingMinutes
                      })
                    }}
                  </div>
                </template>
                <strong class="restaurant-name content-large">{{
                  company.name
                }}</strong>
                <div
                  class="caption restaurant-address"
                  :class="isRecommendation ? 'mb-0' : ''"
                >
                  {{ restaurant.buildingAddress }}
                </div>
                <div
                  class="caption restaurant-tags"
                  :class="isRecommendation ? 'mb-0' : ''"
                >
                  {{
                    restaurant.restaurantTypes
                      .map(typ => $t(`restaurantTypes.${typ}`))
                      .join(",")
                  }}
                </div>
              </div>
            </component>
            <!-- Tabs -->
            <div class="row tabs" :class="tabsClasses">
              <div v-for="(tab, key) in tabs" class="col col-3" :key="key">
                <router-link
                  class="d-block tab"
                  :class="[
                    `tab--${key}`,
                    { 'tab--disabled': !buttonShowStrategy(key) }
                  ]"
                  :to="buttonShowStrategy(key) ? tabLink(key) : { path: false }"
                >
                  <span class="tab__cube">
                    <img
                      :src="`/static/images/icons/${key}-color.png`"
                      alt=""
                    />
                    <span>{{ tab }}</span>
                  </span>
                </router-link>
              </div>
              <div class="col col-12 divider"></div>
              <div class="col col-12">
                <div v-if="isWaitingStrategy">
                  <template v-if="!restaurant.closed">
                    <div>
                      <button
                        @click.prevent.stop="goToFormPage()"
                        class="slut-button"
                        v-if="restaurant.waitingCount > 0"
                      >
                        <span
                          class="restaurant-status restaurant-status--waiting d-inline-block"
                          :class="themeClasses"
                        >
                          <img src="/static/images/icons/wait.png" alt="" />
                          <span class="waiting-count">{{
                            $t("restaurant.waitingCountDesc", {
                              waitingCount: restaurant.waitingCount
                            })
                          }}</span>
                        </span>
                      </button>
                      <div
                        class="restaurant-status restaurant-status--available d-inline-block"
                        :class="themeClasses"
                        v-else
                      >
                        <img src="/static/images/icons/seat.png" alt="" />
                        <span>{{
                          $t("restaurant.waitingStatus.nowAvailable")
                        }}</span>
                      </div>
                    </div>
                  </template>
                  <div v-else>
                    <span class="restaurant-status restaurant-status--disabled">
                      <template v-if="restaurant.closed">
                        <span
                          v-if="restaurant.inRestTime && restaurant.openWaiting"
                          >{{ $t("restaurant.temporarilyClosed") }}</span
                        >
                        <span v-else>
                          <template v-if="!restaurant.isAfterFirstOpenTime">{{
                            $t("restaurant.notOpen")
                          }}</template>
                          <template v-else>{{
                            $t("restaurant.waitingStatus.closed")
                          }}</template>
                        </span>
                      </template>
                      <template v-else>
                        <span v-if="!restaurant.inOperation">
                          <template v-if="restaurant.dayOff">
                            <span>{{ $t("restaurant.dayOff") }}</span>
                          </template>
                          <template v-else>
                            <span v-if="!restaurant.isAfterFirstOpenTime">{{
                              $t("restaurant.closedDesc", {
                                nextOpenTimeFrom:
                                  restaurant.firstOpeningTime.from
                              })
                            }}</span>
                            <span v-if="restaurant.inRestTime">{{
                              $t("restaurant.temporarilyClosed")
                            }}</span>
                            <span v-if="restaurant.inClosingTime">{{
                              $t("restaurant.closed")
                            }}</span>
                          </template>
                        </span>
                      </template>
                    </span>
                  </div>
                </div>
                <div v-else>
                  <div class="slot-list-container">
                    <div
                      ref="slotList"
                      class="slot-list"
                      v-if="restaurant.allowBooking"
                    >
                      <div
                        class="slot-item"
                        :class="{
                          'slot-item--disabled':
                            !slot.active || !restaurant.allowBooking
                        }"
                        v-for="(slot, key) in currentSlots"
                        :key="key"
                      >
                        <a
                          @click.stop.prevent="goToFormPage(slot)"
                          class="slot-btn"
                          >{{ slot.time }}</a
                        >
                      </div>
                    </div>
                  </div>
                  <div class="restaurant-status restaurant-status--disabled">
                    <div v-if="restaurant.slots.length && !currentSlots.length">
                      {{ $t("restaurant.noSlotAtSession") }}
                    </div>
                    <div
                      v-if="
                        !restaurant.slots.length || !restaurant.allowBooking
                      "
                    >
                      {{ $t("restaurant.bookingDisabled") }}
                    </div>
                    <!-- todo: 餐廳不提供線上訂位 -->
                  </div>
                </div>
              </div>
            </div>
          </div>
        </component>
      </template>
      <template v-else>
        <div class="restaurant loading">
          <div class="flex d-md-block">
            <div>
              <div class="restaurant-logo lp"></div>
            </div>
            <div
              class="restaurant-content flex-1 flex flex-column justify-content-between"
            >
              <strong class="restaurant-name content-large lp"></strong>
              <div class="caption restaurant-address lp"></div>
              <div class="caption restaurant-tags lp"></div>
              <div class="restaurant-status lp"></div>
            </div>
          </div>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
import { mapState, mapGetters } from "vuex";
import $ from "jquery";
import { isNowBetween, isTimeBetween } from "@/utils";
import capitalize from "lodash/capitalize";
import { restaurantServiceStrategy } from "@/utils";

export default {
  props: {
    restaurant: {
      type: Object
    },
    strategy: {
      type: String
    },
    listType: {
      type: String
    }
  },
  data: function() {
    return {
      tabs: this.$t("restaurant.tab"),
      service: {
        booking: true,
        waiting: true,
        preorder: true,
        delivery: "disabled"
      }
    };
  },
  computed: {
    ...mapState(["isMobile"]),
    ...mapGetters("group", ["sessionTime"]),
    ...mapState("group", ["filter"]),
    ...mapGetters("account", ["isVipMember", "isLogin"]),
    ...mapGetters("theme", ["themeClasses"]),
    company() {
      return this.restaurant.company;
    },
    close() {
      // only waiting strategy will have close status
      return this.strategy === "waiting" && this.restaurant.closed;
    },
    currentSlots() {
      return this.restaurant.slotsWithin(this.isVipMember, this.sessionTime);
    },
    thumbnail() {
      if (this.isMobile) {
        return `${this.restaurant.images[0]}?fit=crop&w=200&h=200&q=90`;
      } else {
        return `${this.restaurant.images[0]}?fit=crop&w=500&h=375&q=95`;
      }
    },
    isRecommendation() {
      return this.listType === "available recommendation";
    },
    tag() {
      return this.isRecommendation ? "router-link" : "div";
    },
    tagForLogo() {
      return !this.isRecommendation ? "router-link" : "div";
    },
    tabsClasses() {
      return this.isRecommendation ? "px-0" : "";
    },
    isWaitingStrategy() {
      return this.strategy === "waiting";
    },
    isBookingStrategy() {
      return !this.isWaitingStrategy;
    }
  },
  methods: {
    buttonShowStrategy(key) {
      return restaurantServiceStrategy(key, this.restaurant);
    },
    goToFormPage(slot) {
      const link = this.link(slot);
      if (this.isLogin) {
        if (this.strategy === "waiting") {
          link.name = "WaitingForm";
        } else if (slot) {
          link.name = "NewReservation";
        }
      }
      this.$router.push(link);
    },
    tabLink(name) {
      const prefixName = "Restaurant";
      return {
        name: `${prefixName}${capitalize(name)}`,
        params: {
          groupId: this.restaurant.groupId,
          companyId: this.company.id,
          id: this.restaurant.id
        }
      };
    },
    link(slot) {
      var name =
        this.strategy === "waiting" ? "RestaurantWaiting" : "RestaurantBooking";

      return {
        name,
        params: {
          groupId: this.restaurant.groupId,
          companyId: this.company.id,
          id: this.restaurant.id
        },
        query: this.query(slot)
      };
    },
    query(slot) {
      const params = {
        date: this.filter.date,
        groupSize: this.filter.numOfPersons,
        listType: this.listType
      };
      if (slot) {
        params.time = slot.time;
        params.from = "slot";
      }
      return params;
    }
  }
};
</script>
<style lang="scss" scoped>
.restaurant {
  display: block;
  padding: 12px $grid-gutter-width/2;
  color: $color-primary-black;
  margin-bottom: 14px;
}

.restaurant--close {
  .restaurant-logo:before {
    content: "已關閉";
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: rgba(0, 0, 0, 0.5);
    color: $color-white;
  }
}

.restaurant-block {
  &-top {
    margin-bottom: 16px;
    &:hover {
      color: $color-skm-red !important;
    }
  }
  &-bottom {
  }
}

.restaurant-name {
  font-size: 16px;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  margin-bottom: 10px;
  color: #000000;

  .waiting-minutes-badge ~ & {
    width: 100px;
    @include media-breakpoint-up(sm) {
      width: auto;
    }
  }

  @include media-breakpoint-up(sm, $grid-breakpoints) {
    font-size: 18px;
  }

  @include media-breakpoint-up(md) {
    margin-bottom: 5px;
    line-height: 1;
  }
}

.restaurant-logo {
  position: relative;
  width: 110px;
  height: 110px;
  border-radius: 2px;
  background-size: cover;
  background-position: center;

  @include media-breakpoint-up(md) {
    width: 100%;
    height: auto;
    padding-bottom: 75%;
  }
}

.restaurant-content {
  position: relative;
  margin-left: 1em;
  padding: 0.25em 0;
  overflow: hidden;

  @include media-breakpoint-up(md) {
    margin-left: 0px;
    padding: 16px 0 0 0;
  }
}

.slot-list-container {
  width: 100%;
  height: 26px;
  overflow: hidden;
  .slot-list {
    display: flex;
    flex: row;
    height: 56px;
    overflow-x: scroll;
    overflow-y: hidden;
    -webkit-overflow-scrolling: touch;
  }
}

.restaurant-tags,
.restaurant-address {
  line-height: 1.23;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
  @include media-breakpoint-up(md) {
    line-height: 1.6;
  }
}

.restaurant-tags {
  font-size: 14px;
  color: $color-primary-grey;
  @include media-breakpoint-up(md) {
    margin-bottom: 10px;
  }
}

.restaurant-address {
  font-size: 14px;
  color: $color-primary-black;
  margin-bottom: 10px;
}

.restaurant-status {
  font-size: 14px;
  // @include media-breakpoint-up(sm, $grid-breakpoints) {
  //   font-size: 16px;
  // }
}
.restaurant-status--disabled {
  color: $color-pigeon-grey;
}

.restaurant-status--waiting {
  .waiting-desc {
    display: inline-block;
    color: $color-white;
    background-color: $color-skm-red;
    line-height: 26px;
    padding: 0 0.5em;
    border-radius: 2px;
    margin-right: 0.5em;
  }

  img {
    vertical-align: middle;
    width: 10px;
    margin-right: 2px;
  }

  .waiting-count {
    font-size: 14px;
    color: $color-skm-red;
  }

  &.theme-vip-member {
    .waiting-desc {
      background-color: $color-skm-gold;
    }
  }
}

.restaurant-status--available {
  color: $color-dodger-blue;
  // background-color: $color-dodger-blue;
  border-radius: 2px;
  padding: 0 0.75em 0 0;
  line-height: 26px;
  font-size: 14px;
  img {
    width: 10px;
    vertical-align: middle;
    margin-right: 2px;
  }
  &.theme-vip-member {
    // background-color: #7c683b;
  }
}

.slot-btn {
  appearance: none;
  color: $color-white !important;
  background-color: $color-skm-red;
  border-radius: 2px;
  padding: 0 0.75em;
  line-height: 26px;
  display: inline-block;
  border: none;
  cursor: pointer;

  .slot-item--disabled & {
    pointer-events: none;
    border-color: $color-mineral-ice;
    background-color: $color-mineral-ice;
    color: $color-silver-grey;
  }
}

.slot-item {
  & + & {
    margin-left: 0.625em;
  }
  &:last-child {
    padding-right: $grid-gutter-width/2;
  }
}

.waiting-minutes-badge {
  position: absolute;
  right: 0px;
  top: 5px;
  padding: 0.5em 0.4em;
  font-size: 12px;
  border-radius: 12px;
  color: $color-secondary-black;
  background-color: $color-sky-grey;
  line-height: 1;
  font-weight: 500;

  @include media-breakpoint-up(md) {
    top: 14px;
  }
}

// group list style

.restaurant-list {
  .restaurant {
    background-color: $color-genesis-white;
    transition: all 0.3s;
    &:hover {
      // background-color: $color-genesis-white;
    }
    @include media-breakpoint-up(md) {
      padding: 10px;
      background-color: $color-white;
      border-color: transparent;
      &:hover {
        // background-color: $color-white;
        background-color: $color-genesis-white;
        box-shadow: 0 6px 12px 0 rgba(0, 0, 0, 0.1);
      }
    }
  }

  .restaurant-item {
    min-width: 0;
    @include media-breakpoint-up(md) {
      flex: 0 1 50%;
    }
    @include media-breakpoint-up(xl) {
      flex: 0 1 33.333%;
    }
  }

  .restaurant-item-inner-wrapper {
    @include media-breakpoint-up(md) {
      padding: 0 15px 30px 15px;
    }

    &.theme-vip-member {
      .restaurant {
        background-color: $color-white;
      }
    }
  }
}

// alternative restaurant style
.alternative-restaurant {
  .restaurant-name {
    font-size: 16px;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
  }
  .restaurant-status {
    font-size: 12px;
  }
  .restaurant-content {
    padding: 10px 0;
  }
  .waiting-minutes-badge {
    display: none;
  }
  .tabs {
    .col-3,
    .divider {
      display: none;
    }
    .col-12 {
      max-width: 100% !important;
      width: 100% !important;
    }
  }
}

.loading {
  .restaurant-name,
  .restaurant-tags {
    width: 68px;
  }
  .restaurant-address {
    width: 185px;
  }
  .restaurant-status {
    width: 106px;
  }
}

.slut-button {
  display: inline-block;
  background: none;
  border: none;
  padding: 0;
  cursor: pointer;
}

.row.tabs {
  margin-left: -4px;
  margin-right: -4px;

  .col {
    padding: 0 4px;
  }

  .divider {
    height: 12px;
  }

  .tab {
    background-color: $white;
    text-align: center;
    *vertical-align: middle;
    padding: 10px 0;
    margin-bottom: 0;
    border-radius: 4px;
    box-shadow: 0px 0px 10px 1px rgba(0, 0, 0, 0.1);
    color: $color-primary-black;
    font-size: 14px;
    img {
      width: 20px;
      margin-right: 2px;
    }

    &--booking {
      border-bottom: 2px solid map_get($tab-colors, "booking");
    }

    &--waiting {
      border-bottom: 2px solid map_get($tab-colors, "waiting");
    }

    &--preorder {
      border-bottom: 2px solid map_get($tab-colors, "preorder");
    }

    &--delivery {
      border-bottom: 2px solid map_get($tab-colors, "delivery");
    }

    &--disabled {
      cursor: not-allowed;
      background-color: $color-genesis-white !important;
      color: $color-silver-grey;
      border-bottom: 2px solid $color-silver-grey;
      .tab__cube {
        img {
          opacity: 0.5;
        }
      }
      .tab__check {
        color: $color-genesis-white !important;
      }
    }
  }
}
</style>
